> ## Documentation Index
> Fetch the complete documentation index at: https://docs.julep.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Developer Secret

> Create a new secret for a developer.

Args:
    developer_id: ID of the developer creating the secret
    secret: Secret to create

Returns:
    The created secret

Raises:
    HTTPException: If a secret with this name already exists (409 Conflict)



## OpenAPI

````yaml https://api.julep.ai/api/openapi.json post /secrets
openapi: 3.1.0
info:
  title: Julep Agents API
  description: API for Julep Agents
  termsOfService: https://www.julep.ai/terms
  contact:
    name: Julep
    url: https://www.julep.ai/
    email: developers@julep.ai
  version: 0.4.0
servers:
  - url: /api
security: []
paths:
  /secrets:
    post:
      tags:
        - secrets
      summary: Create Developer Secret
      description: |-
        Create a new secret for a developer.

        Args:
            developer_id: ID of the developer creating the secret
            secret: Secret to create

        Returns:
            The created secret

        Raises:
            HTTPException: If a secret with this name already exists (409 Conflict)
      operationId: create_developer_secret_secrets_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateSecretRequest'
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Secret'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    CreateSecretRequest:
      properties:
        metadata:
          anyOf:
            - type: object
            - type: 'null'
          title: Metadata
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        value:
          type: string
          title: Value
      type: object
      required:
        - name
        - value
      title: CreateSecretRequest
    Secret:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          readOnly: true
        created_at:
          type: string
          format: date-time
          title: Created At
          readOnly: true
        updated_at:
          type: string
          format: date-time
          title: Updated At
          readOnly: true
        metadata:
          anyOf:
            - type: object
            - type: 'null'
          title: Metadata
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        value:
          type: string
          title: Value
      type: object
      required:
        - id
        - created_at
        - updated_at
        - name
        - value
      title: Secret
      description: A secret that can be used in tasks and sessions
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization

````